using System.Collections.Generic;
using System.Linq;
using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace BerryUser
{
    public static class Item
    {

	
	private static bool HasAnyAura(this WoWUnit unit, params string[] auraNames)
        {
            WoWAuraCollection auras = unit.GetAllAuras();
            var hashes = new HashSet<string>(auraNames);
            return auras.Any(a => hashes.Contains(a.Name));
        }

        private static void UseItemId(uint id)
        {
            foreach (WoWItem item in StyxWoW.Me.BagItems.Where(item => item.Entry == id).Where(CanUseItem))
            {
                UseItem(item);
                return;
            }
        }

        private static bool CanUseItem(WoWItem item)
        {
            return item.Usable && item.Cooldown <= 0;
        }

        private static void UseItem(WoWItem item)
        {
            
            if (CanUseItem(item))
            {
                item.Use();

            }
        }

        public static void begin()
        {
            CreateUseBerryBehavior();
        }


        private static void CreateUseBerryBehavior()
        {	
			if(StyxWoW.Me.HasAnyAura("Kafa Rush")) return;  // Doesn't do anything if it haves Berry aura
			if(StyxWoW.Me.CurrentTarget == null) return;	// Doesn't do anything if it doesn't have a target
            UseItemId(81054);								// Kafa kota berry from WowHead ID
        }

        
    }
}